(in-package :lkb)

;;;----------------------------------------------------------------------
;;; Grammar dependent settings
;;; Should go into user-fns.lsp or globals.lsp

; how to find out whether lexemes or words should be used? -> grammar writer
; for ERG: grep -E '_le\b' lexicon.tdl  | perl -pe '$_ =~ s/.*:=\s*(.+_le)\s*.*/$1/g;' | sort -u
(defparameter *unknown-word-types* '(unknown-word))

(defparameter *maximum-number-of-edges* 50000)
(defparameter *maximal-lex-rule-applications* 5)

(defparameter *sense-unif-fn* #'make-sense-unifications)
;;; [ STEM [ FIRST <string>,
;;;          LAST <> ],
;;;   SYNSEM.LOCAL.KEYS.KEY.LABEL.FIRST <string>_rel ]

(defun make-unknown-word-sense-unifications (word-string)
  (let ((word-string (string-downcase word-string)))
  (when word-string
    (list 
       (make-unification :lhs
          (create-path-from-feature-list (append *orth-path* *list-head*))
          :rhs (make-u-value :type word-string))
       (make-unification :lhs
          (create-path-from-feature-list (append *orth-path* *list-tail*))
          :rhs (make-u-value :type *empty-list-type*))
       (make-unification :lhs
          (create-path-from-feature-list '(SYNSEM LKEYS KEYREL PRED))
          :rhs (make-u-value :type 
                             (concatenate 'string word-string "_rel")))))))

(defparameter *unknown-word-compression* 'grammar)
(defparameter *unknown-word-drop-paths* '
    (
     (STEM REST) 
     (SYNSEM LOCAL CAT HEAD MOD)))
(defparameter *unknown-word-unknown-word-type* 'unknown-word)
